function read_query(packet)
   local threshold = 2
   local file_name = ""
   if string.byte(packet) == proxy.COM_QUERY then
	  query = string.sub(packet, 2)
	  local b = io.open(file_name .. "logs/db_banned.log", "r")
	  local banned = false
	  while true do
		 local raw_line = b:read("*line")
		 if not raw_line then break end
		 num = split(raw_line,";")[1]+0
		 cmd = split(raw_line,";")[2]
		 print("query is " .. query)
		 --[[print("string.find(query, cmd) " .. string.find(query, cmd))
		 print("type of query is " .. type(query))
			print("type of cmd is " .. type(cmd))]]--
		 if string.find(query, cmd) and num >=threshold then
			banned = true
		 end
	  end
	  a,b = string.match(query, '[Aa][Nn][Dd]%s+([^%s]*)%s*=%s*([^%s]*)')
	  if a and a==b then banned = true end
	  a,b = string.match(query, '%s+([^%s]*)%s*=%s*([^%s]*)%s+[Aa][Nn][Dd]')
	  if a and a==b then banned = true end
	  a,b = string.match(query, '[Oo][Rr]%s+([^%s]*)%s*=%s*([^%s]*)')
	  if a and a==b then banned = true end
	  a,b = string.match(query, '%s*+([^%s]*)%s*=%s*([^%s]*)%s+[Oo][Rr]')
	  if a and a==b then banned = true end
	  if string.match(query, '[Aa][Nn][Dd]%s+[^%s=]+%s*$') then banned = true end
	  if string.match(query, '[Aa][Nn][Dd]%s+[^%s=]+%s*[Aa][Nn][Dd]') then banned = true end
	  if string.match(query, '[Aa][Nn][Dd]%s+[^%s=]+%s*[Oo][Rr]') then banned = true end
	  if string.match(query, '[Oo][Rr]%s+[^%s=]+%s*$') then banned = true end
	  if string.match(query, '[Oo][Rr]%s+[^%s=]+%s*[Aa][Nn][Dd]') then banned = true end
	  if string.match(query, '[Oo][Rr]%s+[^%s=]+%s*[Oo][Rr]') then banned = true end
	  if string.match(query, '%-%-') then banned = true end
	  if string.match(query, '#') then banned = true end
	  if string.match(query, '%/%*') then banned = true end
	  if banned == false then
		 log_query(query)
	  else
		 log_query("BANNED;"..query)
		 proxy.response.type = proxy.MYSQLD_PACKET_ERR
		 proxy.response.errmsg = "Banned SQL command: " .. query
		 
		 return proxy.PROXY_SEND_RESULT
	  end
	  return true
   end
end

function log_query(query)
   local file_name = ""
   output = os.date() .. ";QUERY;" .. query
   print(output)
   local l_log = io.open(file_name .. "logs/db_l_logs.log", "a")
   l_log:write(output .. "\n")
   l_log:flush()
   l_log:close()
   local s_log = io.open(file_name .. "logs/db_s_logs.log", "rw")
   local lines = ""
   s_log:read("*line")
   while true do
	  local line = s_log:read("*line")
	  if not line then break end
	  lines = lines .. line .. "\n"
   end
   lines = lines .. output .. "\n"
   s_log:close()
   s_log = io.open(file_name .. "logs/db_s_logs.log", "w")
   s_log:write(lines)
   s_log:flush()
   s_log:close()
   return true
end

function split(str, pat)
   local t = {}  -- NOTE: use {n = 0} in Lua-5.0
   local fpat = "(.-)" .. pat
   local last_end = 1
   local s, e, cap = str:find(fpat, 1)
   while s do
      if s ~= 1 or cap ~= "" then
	 table.insert(t,cap)
      end
      last_end = e+1
      s, e, cap = str:find(fpat, last_end)
   end
   if last_end <= #str then
      cap = str:sub(last_end)
      table.insert(t, cap)
   end
   return t
end